From SyDPaCC.Support.Lists 
     Require Export Assoc Filter Length Map Member NoDup Seq.

Generalizable All Variables.
Require Import Coq.Lists.List. Import ListNotations.
Set Implicit Arguments.

(** * Additional Results about Functions on Lists *)

Lemma combine_app:
  forall A B (l1 l2:list A)(l1' l2':list B),
    length l1 = length l1' ->
    combine(l1++l2)(l1'++l2') =
    combine l1 l1' ++ combine l2 l2'.
Proof.
  intros A B; induction l1 as [ | h1 t1 IH]; intros l2 l1' l2' H; destruct l1' as [ | h1' t1' ]; simpl.
  - trivial.
  - simpl in H; discriminate.
  - simpl in H; discriminate.
  - simpl in H; inversion H as [ H' ]; subst; clear H.
    now rewrite IH.
Qed.

Lemma list_last_app:
  forall A (xs:list A) x d,
    List.last (xs++[x]) d = x.
Proof.
  intros A; induction xs; intros x d.
  - now compute.
  - simpl; destruct(xs ++ [x]) eqn:H; symmetry in H.
    + apply app_cons_not_nil in H; now exfalso.
    + destruct xs; inversion H; subst; auto.
      rewrite app_comm_cons; apply IHxs.
Qed.
